unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    groupbox_game_sheet: TGroupBox;
    groupbox_0_0: TGroupBox;
    edit_0_0: TEdit;
    edit_0_1: TEdit;
    edit_0_2: TEdit;
    edit_1_0: TEdit;
    edit_1_1: TEdit;
    edit_1_2: TEdit;
    edit_2_0: TEdit;
    edit_2_1: TEdit;
    edit_2_2: TEdit;
    groupbox_0_1: TGroupBox;
    edit_0_3: TEdit;
    edit_0_4: TEdit;
    edit_0_5: TEdit;
    edit_1_3: TEdit;
    edit_1_4: TEdit;
    edit_1_5: TEdit;
    edit_2_3: TEdit;
    edit_2_4: TEdit;
    edit_2_5: TEdit;
    groupbox_0_2: TGroupBox;
    edit_0_6: TEdit;
    edit_0_7: TEdit;
    edit_0_8: TEdit;
    edit_1_6: TEdit;
    edit_1_7: TEdit;
    edit_1_8: TEdit;
    edit_2_6: TEdit;
    edit_2_7: TEdit;
    edit_2_8: TEdit;
    groupbox_1_0: TGroupBox;
    edit_3_0: TEdit;
    edit_3_1: TEdit;
    edit_3_2: TEdit;
    edit_4_0: TEdit;
    edit_4_1: TEdit;
    edit_4_2: TEdit;
    edit_5_0: TEdit;
    edit_5_1: TEdit;
    edit_5_2: TEdit;
    groupbox_1_1: TGroupBox;
    edit_3_3: TEdit;
    edit_3_4: TEdit;
    edit_3_5: TEdit;
    edit_4_3: TEdit;
    edit_4_4: TEdit;
    edit_4_5: TEdit;
    edit_5_3: TEdit;
    edit_5_4: TEdit;
    edit_5_5: TEdit;
    groupbox_1_2: TGroupBox;
    edit_3_6: TEdit;
    edit_3_7: TEdit;
    edit_3_8: TEdit;
    edit_4_6: TEdit;
    edit_4_7: TEdit;
    edit_4_8: TEdit;
    edit_5_6: TEdit;
    edit_5_7: TEdit;
    edit_5_8: TEdit;
    groupbox_2_0: TGroupBox;
    edit_6_0: TEdit;
    edit_6_1: TEdit;
    edit_6_2: TEdit;
    edit_7_0: TEdit;
    edit_7_1: TEdit;
    edit_7_2: TEdit;
    edit_8_0: TEdit;
    edit_8_1: TEdit;
    edit_8_2: TEdit;
    groupbox_2_1: TGroupBox;
    edit_6_3: TEdit;
    edit_6_4: TEdit;
    edit_6_5: TEdit;
    edit_7_3: TEdit;
    edit_7_4: TEdit;
    edit_7_5: TEdit;
    edit_8_3: TEdit;
    edit_8_4: TEdit;
    edit_8_5: TEdit;
    groupbox_2_2: TGroupBox;
    edit_6_6: TEdit;
    edit_6_7: TEdit;
    edit_6_8: TEdit;
    edit_7_6: TEdit;
    edit_7_7: TEdit;
    edit_7_8: TEdit;
    edit_8_6: TEdit;
    edit_8_7: TEdit;
    edit_8_8: TEdit;
    button_solve: TButton;
    Label1: TLabel;
    label_status: TLabel;
    listbox_status: TListBox;
    procedure button_solveClick(Sender: TObject);
  private
    { Private-Deklarationen }
    field: array[0..8] of array[0..8] of Byte;
    missed_in_box: array[0..2] of array[0..2] of array of Byte;
    missed_in_row: array[0..8] of array of Byte;
    missed_in_col: array[0..8] of array of Byte;
    procedure read_input();
    procedure write_output();
    procedure remove_number_from_missed_in_box(box_r:Byte; box_c:Byte; number:Byte);
    procedure remove_number_from_missed_in_row(row:Byte; number:Byte);
    procedure remove_number_from_missed_in_col(col:Byte; number:Byte);
    function solveFinished():Bool;
    function getBoxColFromCol(col: Byte):Byte;
    function getBoxRowFromRow(row: Byte):Byte;
    function look_for_number_in_box(box_r:Byte; box_c:Byte; number:Byte):Bool;
    function look_for_number_in_row(row:Byte; number:Byte):Bool;
    function look_for_number_in_col(col:Byte; number:Byte):Bool;
    function check_missed_number_in_box(box_r:Byte; box_c:Byte; number:Byte):Bool;
    function check_missed_number_in_row(row:Byte; number:Byte):Bool;
    function check_missed_number_in_col(col:Byte; number:Byte):Bool;
    function get_number_sting_of_missed_numbers_in_box(box_r:Byte; box_c:Byte):AnsiString;
    function get_number_sting_of_missed_numbers_in_row(row:Byte):AnsiString;
    function get_number_sting_of_missed_numbers_in_col(col:Byte):AnsiString;
  public
    { Public-Deklarationen }
  end;

var
  form_main: TForm1;

implementation

{$R *.dfm}

procedure TForm1.button_solveClick(Sender: TObject);
var
  i, j, box_r, box_c, row, col, number: Byte;
  single_pos, setted: Bool;

begin
  // read input
  read_input();

  // look wich numbers are missing in the several boxes
  for box_r:=0 to 2 do
  for box_c:=0 to 2 do
  begin
    setlength(missed_in_box[box_r,box_c], 0);
    for number:=1 to 9 do
    begin
      if look_for_number_in_box(box_r, box_c, number) = false then
      begin
        setlength(missed_in_box[box_r,box_c], length(missed_in_box[box_r,box_c])+1);
        missed_in_box[box_r,box_c][length(missed_in_box[box_r,box_c])-1] := number;
      end;
    end;
    listbox_status.AddItem('Missed numbers in box ['+inttostr(box_r+1)+','+inttostr(box_c+1)+']: '+inttostr(length(missed_in_box[box_r,box_c]))+': '+get_number_sting_of_missed_numbers_in_box(box_r, box_c), listbox_status);
  end;

  // look wich numbers are missing in the several rows
  for i:=0 to 8 do
  begin
    setlength(missed_in_row[i], 0);
    for number:=1 to 9 do
    begin
      if look_for_number_in_row(i, number) = false then
      begin
        setlength(missed_in_row[i], length(missed_in_row[i])+1);
        missed_in_row[i][length(missed_in_row[i])-1] := number;
      end;
    end;
    listbox_status.AddItem('Missed numbers in row ['+inttostr(i+1)+']: '+inttostr(length(missed_in_row[i]))+': '+get_number_sting_of_missed_numbers_in_row(i), listbox_status);
  end;

  // look wich numbers are missing in the several coloums
  for j:=0 to 8 do
  begin
    setlength(missed_in_col[j], 0);
    for number:=1 to 9 do
    begin
      if look_for_number_in_col(j, number) = false then
      begin
        setlength(missed_in_col[j], length(missed_in_col[j])+1);
        missed_in_col[j][length(missed_in_col[j])-1] := number;
      end;
    end;
    listbox_status.AddItem('Missed numbers in col ['+inttostr(j+1)+']: '+inttostr(length(missed_in_col[j]))+': '+get_number_sting_of_missed_numbers_in_col(j), listbox_status);
  end;

  // solve
  setted := true;
  while (solveFinished() = false) and (setted = true) do
  begin
    setted := false;
    for number:=1 to 9 do
    begin
      for row:=0 to 8 do
      for col:=0 to 8 do
      begin
        if field[row,col] > 0 then continue;
        // check if number is missed in current box, row and coloum
        box_r := getBoxRowFromRow(row);
        box_c := getBoxColFromCol(col);
        if (check_missed_number_in_box(box_r, box_c, number) = true) and
           (check_missed_number_in_row(row, number)          = true) and
           (check_missed_number_in_col(col, number)          = true)
        then
        begin
          // check for single position to set
          single_pos := true;
          for i:=(box_r*3) to (box_r*3+2) do
          begin
            if single_pos = false then break;
            for j:=(box_c*3) to (box_c*3+2) do
            begin
              if (i = row) and (j = col) then continue;
              if field[i,j] > 0 then continue;
              if (check_missed_number_in_row(i, number) = true) and
                 (check_missed_number_in_col(j, number) = true)
              then
              begin
                single_pos := false;
                break;
              end;
            end;
          end;

          if single_pos = false then continue;

          // position is single, set number to field
          field[row,col] := number;
          setted := true;

          // remove number from missed number lists
          remove_number_from_missed_in_box(box_r, box_c, number);
          remove_number_from_missed_in_row(row, number);
          remove_number_from_missed_in_col(col, number);
        end;
      end;
    end;
  end;

  // print output
  if solveFinished() = true then
  begin
    label_status.Caption := 'Solve successfully complite!';
    write_output();
  end
  else if setted = false then
  begin
    label_status.Caption := 'Game sheet not solveable!';
  end
  else
  begin
    label_status.Caption := 'Fatal unkown error!';
  end;

end;

procedure TForm1.read_input();
begin
  listbox_status.Clear;

  field[0,0] := strtoint(edit_0_0.Text);
  field[0,1] := strtoint(edit_0_1.Text);
  field[0,2] := strtoint(edit_0_2.Text);
  field[0,3] := strtoint(edit_0_3.Text);
  field[0,4] := strtoint(edit_0_4.Text);
  field[0,5] := strtoint(edit_0_5.Text);
  field[0,6] := strtoint(edit_0_6.Text);
  field[0,7] := strtoint(edit_0_7.Text);
  field[0,8] := strtoint(edit_0_8.Text);

  field[1,0] := strtoint(edit_1_0.Text);
  field[1,1] := strtoint(edit_1_1.Text);
  field[1,2] := strtoint(edit_1_2.Text);
  field[1,3] := strtoint(edit_1_3.Text);
  field[1,4] := strtoint(edit_1_4.Text);
  field[1,5] := strtoint(edit_1_5.Text);
  field[1,6] := strtoint(edit_1_6.Text);
  field[1,7] := strtoint(edit_1_7.Text);
  field[1,8] := strtoint(edit_1_8.Text);

  field[2,0] := strtoint(edit_2_0.Text);
  field[2,1] := strtoint(edit_2_1.Text);
  field[2,2] := strtoint(edit_2_2.Text);
  field[2,3] := strtoint(edit_2_3.Text);
  field[2,4] := strtoint(edit_2_4.Text);
  field[2,5] := strtoint(edit_2_5.Text);
  field[2,6] := strtoint(edit_2_6.Text);
  field[2,7] := strtoint(edit_2_7.Text);
  field[2,8] := strtoint(edit_2_8.Text);

  field[3,0] := strtoint(edit_3_0.Text);
  field[3,1] := strtoint(edit_3_1.Text);
  field[3,2] := strtoint(edit_3_2.Text);
  field[3,3] := strtoint(edit_3_3.Text);
  field[3,4] := strtoint(edit_3_4.Text);
  field[3,5] := strtoint(edit_3_5.Text);
  field[3,6] := strtoint(edit_3_6.Text);
  field[3,7] := strtoint(edit_3_7.Text);
  field[3,8] := strtoint(edit_3_8.Text);

  field[4,0] := strtoint(edit_4_0.Text);
  field[4,1] := strtoint(edit_4_1.Text);
  field[4,2] := strtoint(edit_4_2.Text);
  field[4,3] := strtoint(edit_4_3.Text);
  field[4,4] := strtoint(edit_4_4.Text);
  field[4,5] := strtoint(edit_4_5.Text);
  field[4,6] := strtoint(edit_4_6.Text);
  field[4,7] := strtoint(edit_4_7.Text);
  field[4,8] := strtoint(edit_4_8.Text);

  field[5,0] := strtoint(edit_5_0.Text);
  field[5,1] := strtoint(edit_5_1.Text);
  field[5,2] := strtoint(edit_5_2.Text);
  field[5,3] := strtoint(edit_5_3.Text);
  field[5,4] := strtoint(edit_5_4.Text);
  field[5,5] := strtoint(edit_5_5.Text);
  field[5,6] := strtoint(edit_5_6.Text);
  field[5,7] := strtoint(edit_5_7.Text);
  field[5,8] := strtoint(edit_5_8.Text);

  field[6,0] := strtoint(edit_6_0.Text);
  field[6,1] := strtoint(edit_6_1.Text);
  field[6,2] := strtoint(edit_6_2.Text);
  field[6,3] := strtoint(edit_6_3.Text);
  field[6,4] := strtoint(edit_6_4.Text);
  field[6,5] := strtoint(edit_6_5.Text);
  field[6,6] := strtoint(edit_6_6.Text);
  field[6,7] := strtoint(edit_6_7.Text);
  field[6,8] := strtoint(edit_6_8.Text);

  field[7,0] := strtoint(edit_7_0.Text);
  field[7,1] := strtoint(edit_7_1.Text);
  field[7,2] := strtoint(edit_7_2.Text);
  field[7,3] := strtoint(edit_7_3.Text);
  field[7,4] := strtoint(edit_7_4.Text);
  field[7,5] := strtoint(edit_7_5.Text);
  field[7,6] := strtoint(edit_7_6.Text);
  field[7,7] := strtoint(edit_7_7.Text);
  field[7,8] := strtoint(edit_7_8.Text);

  field[8,0] := strtoint(edit_8_0.Text);
  field[8,1] := strtoint(edit_8_1.Text);
  field[8,2] := strtoint(edit_8_2.Text);
  field[8,3] := strtoint(edit_8_3.Text);
  field[8,4] := strtoint(edit_8_4.Text);
  field[8,5] := strtoint(edit_8_5.Text);
  field[8,6] := strtoint(edit_8_6.Text);
  field[8,7] := strtoint(edit_8_7.Text);
  field[8,8] := strtoint(edit_8_8.Text);
end;

procedure TForm1.write_output();
begin
  edit_0_0.Text := inttostr(field[0,0]);
  edit_0_1.Text := inttostr(field[0,1]);
  edit_0_2.Text := inttostr(field[0,2]);
  edit_0_3.Text := inttostr(field[0,3]);
  edit_0_4.Text := inttostr(field[0,4]);
  edit_0_5.Text := inttostr(field[0,5]);
  edit_0_6.Text := inttostr(field[0,6]);
  edit_0_7.Text := inttostr(field[0,7]);
  edit_0_8.Text := inttostr(field[0,8]);

  edit_1_0.Text := inttostr(field[1,0]);
  edit_1_1.Text := inttostr(field[1,1]);
  edit_1_2.Text := inttostr(field[1,2]);
  edit_1_3.Text := inttostr(field[1,3]);
  edit_1_4.Text := inttostr(field[1,4]);
  edit_1_5.Text := inttostr(field[1,5]);
  edit_1_6.Text := inttostr(field[1,6]);
  edit_1_7.Text := inttostr(field[1,7]);
  edit_1_8.Text := inttostr(field[1,8]);

  edit_2_0.Text := inttostr(field[2,0]);
  edit_2_1.Text := inttostr(field[2,1]);
  edit_2_2.Text := inttostr(field[2,2]);
  edit_2_3.Text := inttostr(field[2,3]);
  edit_2_4.Text := inttostr(field[2,4]);
  edit_2_5.Text := inttostr(field[2,5]);
  edit_2_6.Text := inttostr(field[2,6]);
  edit_2_7.Text := inttostr(field[2,7]);
  edit_2_8.Text := inttostr(field[2,8]);

  edit_3_0.Text := inttostr(field[3,0]);
  edit_3_1.Text := inttostr(field[3,1]);
  edit_3_2.Text := inttostr(field[3,2]);
  edit_3_3.Text := inttostr(field[3,3]);
  edit_3_4.Text := inttostr(field[3,4]);
  edit_3_5.Text := inttostr(field[3,5]);
  edit_3_6.Text := inttostr(field[3,6]);
  edit_3_7.Text := inttostr(field[3,7]);
  edit_3_8.Text := inttostr(field[3,8]);

  edit_4_0.Text := inttostr(field[4,0]);
  edit_4_1.Text := inttostr(field[4,1]);
  edit_4_2.Text := inttostr(field[4,2]);
  edit_4_3.Text := inttostr(field[4,3]);
  edit_4_4.Text := inttostr(field[4,4]);
  edit_4_5.Text := inttostr(field[4,5]);
  edit_4_6.Text := inttostr(field[4,6]);
  edit_4_7.Text := inttostr(field[4,7]);
  edit_4_8.Text := inttostr(field[4,8]);

  edit_5_0.Text := inttostr(field[5,0]);
  edit_5_1.Text := inttostr(field[5,1]);
  edit_5_2.Text := inttostr(field[5,2]);
  edit_5_3.Text := inttostr(field[5,3]);
  edit_5_4.Text := inttostr(field[5,4]);
  edit_5_5.Text := inttostr(field[5,5]);
  edit_5_6.Text := inttostr(field[5,6]);
  edit_5_7.Text := inttostr(field[5,7]);
  edit_5_8.Text := inttostr(field[5,8]);

  edit_6_0.Text := inttostr(field[6,0]);
  edit_6_1.Text := inttostr(field[6,1]);
  edit_6_2.Text := inttostr(field[6,2]);
  edit_6_3.Text := inttostr(field[6,3]);
  edit_6_4.Text := inttostr(field[6,4]);
  edit_6_5.Text := inttostr(field[6,5]);
  edit_6_6.Text := inttostr(field[6,6]);
  edit_6_7.Text := inttostr(field[6,7]);
  edit_6_8.Text := inttostr(field[6,8]);

  edit_7_0.Text := inttostr(field[7,0]);
  edit_7_1.Text := inttostr(field[7,1]);
  edit_7_2.Text := inttostr(field[7,2]);
  edit_7_3.Text := inttostr(field[7,3]);
  edit_7_4.Text := inttostr(field[7,4]);
  edit_7_5.Text := inttostr(field[7,5]);
  edit_7_6.Text := inttostr(field[7,6]);
  edit_7_7.Text := inttostr(field[7,7]);
  edit_7_8.Text := inttostr(field[7,8]);

  edit_8_0.Text := inttostr(field[8,0]);
  edit_8_1.Text := inttostr(field[8,1]);
  edit_8_2.Text := inttostr(field[8,2]);
  edit_8_3.Text := inttostr(field[8,3]);
  edit_8_4.Text := inttostr(field[8,4]);
  edit_8_5.Text := inttostr(field[8,5]);
  edit_8_6.Text := inttostr(field[8,6]);
  edit_8_7.Text := inttostr(field[8,7]);
  edit_8_8.Text := inttostr(field[8,8]);
end;

procedure TForm1.remove_number_from_missed_in_box(box_r:Byte; box_c:Byte; number:Byte);
var
  read_i,write_i: Byte;

begin
  write_i := 0;
  for read_i:=0 to length(missed_in_box[box_r,box_c])-1 do
  begin
    if missed_in_box[box_r,box_c][read_i] = number then continue;
    missed_in_box[box_r,box_c][write_i] := missed_in_box[box_r,box_c][read_i];
    inc(write_i);
  end;
  setlength(missed_in_box[box_r,box_c], length(missed_in_box[box_r,box_c])-1);
end;

procedure TForm1.remove_number_from_missed_in_row(row:Byte; number:Byte);
var
  read_i,write_i: Byte;

begin
  write_i := 0;
  for read_i:=0 to length(missed_in_row[row])-1 do
  begin
    if missed_in_row[row][read_i] = number then continue;
    missed_in_row[row][write_i] := missed_in_row[row][read_i];
    inc(write_i);
  end;
  setlength(missed_in_row[row], length(missed_in_row[row])-1);
end;

procedure TForm1.remove_number_from_missed_in_col(col:Byte; number:Byte);
var
  read_i,write_i: Byte;

begin
  write_i := 0;
  for read_i:=0 to length(missed_in_col[col])-1 do
  begin
    if missed_in_col[col][read_i] = number then continue;
    missed_in_col[col][write_i] := missed_in_col[col][read_i];
    inc(write_i);
  end;
  setlength(missed_in_col[col], length(missed_in_col[col])-1);
end;

function TForm1.solveFinished():Bool;
var
  i: Byte;
  fin: Bool;

begin
  fin := true;
  for i:=0 to 8 do
  begin
    if (length(missed_in_row[i]) > 0) or
       (length(missed_in_col[i]) > 0)
    then
    begin
      fin := false;
      break;
    end;
  end;

  Result := fin;
end;

function TForm1.getBoxColFromCol(col: Byte):Byte;
var
  x:     Real;
  box_c: Byte;

begin
  box_c := 0;
  x := col / 3;
       if (x >= 0) and (x < 1) then box_c := 0
  else if (x >= 1) and (x < 2) then box_c := 1
  else if (x >= 2) and (x < 3) then box_c := 2;

  Result := box_c;
end;

function TForm1.getBoxRowFromRow(row: Byte):Byte;
var
  x:     Real;
  box_r: Byte;

begin
  box_r := 0;
  x := row / 3;
       if (x >= 0) and (x < 1) then box_r := 0
  else if (x >= 1) and (x < 2) then box_r := 1
  else if (x >= 2) and (x < 3) then box_r := 2;

  Result := box_r;
end;

function TForm1.look_for_number_in_box(box_r:Byte; box_c:Byte; number:Byte):Bool;
var
  found: Bool;
  i,j:   Byte;

begin
  found := false;
  for i:=(box_r*3) to (box_r*3+2) do
  begin
    if found = true then break;
    for j:=(box_c*3) to (box_c*3+2) do
    begin
      if field[i,j] = number then
      begin
        found := true;
        break;
      end;
    end;
  end;

  Result := found;
end;

function TForm1.look_for_number_in_row(row:Byte; number:Byte):Bool;
var
  found: Bool;
  j:     Byte;

begin
  found := false;
  for j:=0 to 8 do
  begin
    if field[row,j] = number then
    begin
      found := true;
      break;
    end;
  end;

  Result := found;
end;

function TForm1.look_for_number_in_col(col:Byte; number:Byte):Bool;
var
  found: Bool;
  i:     Byte;

begin
  found := false;
  for i:=0 to 8 do
  begin
    if field[i,col] = number then
    begin
      found := true;
      break;
    end;
  end;

  Result := found;
end;

function TForm1.check_missed_number_in_box(box_r:Byte; box_c:Byte; number:Byte):Bool;
var
  len, i: Byte;
  found:  Bool;

begin
  len := length(missed_in_box[box_r,box_c]);
  if len = 0 then
  begin
    Result := false;
    exit;
  end;
  
  found := false;
  for i:=0 to len-1 do
  begin
    if missed_in_box[box_r,box_c][i] = number then
    begin
      found := true;
      break;
    end;
  end;

  Result := found;
end;

function TForm1.check_missed_number_in_row(row:Byte; number:Byte):Bool;
var
  len, i: Byte;
  found:  Bool;

begin
  len := length(missed_in_row[row]);
  if len = 0 then
  begin
    Result := false;
    exit;
  end;

  found := false;
  for i:=0 to len-1 do
  begin
    if missed_in_row[row][i] = number then
    begin
      found := true;
      break;
    end;
  end;

  Result := found;
end;

function TForm1.check_missed_number_in_col(col:Byte; number:Byte):Bool;
var
  len, i: Byte;
  found:  Bool;

begin
  len := length(missed_in_col[col]);
  if len = 0 then
  begin
    Result := false;
    exit;
  end;

  found := false;
  for i:=0 to len-1 do
  begin
    if missed_in_col[col][i] = number then
    begin
      found := true;
      break;
    end;
  end;

  Result := found;
end;

function TForm1.get_number_sting_of_missed_numbers_in_box(box_r:Byte; box_c:Byte):AnsiString;
var
  len,i: Byte;
  str: AnsiString;

begin
  len := length(missed_in_box[box_r,box_c]);
  if len = 0 then
  begin
    Result := '';
    exit;
  end;
  for i:=0 to len-1 do
  begin
    if i > 0 then str := str + ',';
    str := str + inttostr(missed_in_box[box_r,box_c][i]);
  end;

  Result := str;
end;

function TForm1.get_number_sting_of_missed_numbers_in_row(row:Byte):AnsiString;
var
  len,i: Byte;
  str: AnsiString;

begin
  len := length(missed_in_row[row]);
  if len = 0 then
  begin
    Result := '';
    exit;
  end;
  for i:=0 to len-1 do
  begin
    if i > 0 then str := str + ',';
    str := str + inttostr(missed_in_row[row][i]);
  end;

  Result := str;
end;

function TForm1.get_number_sting_of_missed_numbers_in_col(col:Byte):AnsiString;
var
  len,i: Byte;
  str: AnsiString;

begin
  len := length(missed_in_col[col]);
  if len = 0 then
  begin
    Result := '';
    exit;
  end;
  for i:=0 to len-1 do
  begin
    if i > 0 then str := str + ',';
    str := str + inttostr(missed_in_col[col][i]);
  end;

  Result := str;
end;

end.
